//Histogram of words in stdin.  from Stroustrup
#include <iostream>
#include <map>
#include <string>
#include <algorithm>


void record (const string&);
void print (const pair<string, int>&);

map<string,int> histogram;   //map is associative array: string key, int datum

int main() {
  istream_iterator<string> ii(cin);  //input stream cin to be iterated over,
                                     //reading strings
  istream_iterator<string> eos;    //indicates end of input

  //for_each item iterated over, i.e. all strings from stdin, 
  //passing the string item to record function
  for_each(ii,eos,record);

  //iterate over histogram map, passing each item to print function.
  //item of map is a pair
  for_each(histogram.begin(),histogram.end(),print);
}


void record (const string& s) {
  histogram[s]++;             //increment int datum of key s
}



void print (const pair<string, int>& r) {
  //first is first element of a pair, second is second element of a pair
  cout << r.first << ' ' << r.second << endl;
}



