#include <iostream>
#include <list>
#include <vector>
#include <algorithm>


using namespace std;
template<class ForwardIterator, class T>
void ourreplace (ForwardIterator first, ForwardIterator pastLast,
	      const T& x, const T& y);


main() {
  list<int> nums;            //a list of ints
  list<int>::iterator iter;  //an iterator for a list of ints
  int num;

  cin >> num;
  while (num != -1) {
    nums.push_back(num);    //add to end of list
    cin >> num;
  }
  cout << "Here's the list:" << endl;

  //iterate from beginning to end of list of ints
  for (iter=nums.begin(); iter!=nums.end(); iter++)
    cout << *iter << "  ";   //output what the iterator refers to
  cout << endl;

  //reverse list items from beginning to end, ie. entire list
  reverse(nums.begin(),nums.end());  //args are iterators

  cout << "Here's the reversed list:" << endl;
  for (iter=nums.begin(); iter!=nums.end(); iter++)
    cout << *iter << "  ";
  cout << endl;


  //vector of ints as same values as list.
  vector<int> V(nums.begin(),nums.end());
  vector<int>::iterator viter;  //iterator for a vector of ints

  cout << "Here's the vector:" << endl;
  for (viter=V.begin(); viter!=V.end(); viter++)
    cout << *viter << "  ";
  cout << endl;

  reverse(V.begin(),V.end());   //args are iterators
  cout << "Here's the reversed vector:" << endl;

  for (viter=V.begin(); viter!=V.end(); viter++)
    cout << *viter << "  ";
  cout << endl;


  //play with the replace function.
  cout << endl << "Replace what number by what: ";
  int x, y;
  cin >> x >> y;
  ourreplace(nums.begin(),nums.end(),x,y);
  cout << "Here's the changed list:" << endl;
  for (iter=nums.begin(); iter!=nums.end(); iter++)
    cout << *iter << "  ";  
  cout << endl;

  ourreplace(V.begin(),V.end(),x,y);
  cout << "Here's the changed vector:" << endl;
  for (viter=V.begin(); viter!=V.end(); viter++)
    cout << *viter << "  ";
  cout << endl;



  //sort algorithm:
  sort(V.begin(),V.end());
  cout << "Here's the sorted vector:" << endl;
  for (viter=V.begin(); viter!=V.end(); viter++)
    cout << *viter << "  ";
  cout << endl;


  int A[100];
  for (int i=0; i<100; i++)
    A[i] = rand()%100;
  sort(&A[0],&A[100]);  //one past last
  cout << "Here's the sorted random array:" << endl;
  for (int i=0; i<100; i++)
    cout << A[i] << " ";
  cout << endl;

}



//replace each x by y in any container that supports forward iterators.
//class T must support == and =
template<class ForwardIterator, class T>
void ourreplace (ForwardIterator first, ForwardIterator pastLast,
	      const T& x, const T& y) {

  while (first != pastLast) {   //iterate over items of container
    if (*first == x)      //iterator's referent same as x?
      *first = y;         //assign y to be iterator's referent in container
    ++first;                    //advance iterator to next item
  }
}
